%define _buildid .6

%global python_sitelib %{sys_python_sitelib}
%global __python %{__sys_python}
%global aws_product_name      cfn-init
%global aws_path              /opt/aws
%global aws_bin_path          %{aws_path}/bin
%global aws_product_name_v    %{aws_product_name}-%{version}-%{release}
%global aws_product_path      %{aws_path}/apitools/%{aws_product_name_v}
%global aws_product_path_link %{aws_path}/apitools/%{aws_product_name}

Summary: An EC2 bootstrapper for CloudFormation
Name: aws-cfn-bootstrap
Version: 1.4
Release: 11%{?_buildid}%{?dist}
Source0: %{name}-%{version}-11.tar.gz
License: Apache 2.0
Group: Development/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch: noarch
BuildRequires: system-python
Requires: %{sys_python_pkg}-daemon
Requires: %{sys_python_pkg}-pystache
Requires: %{sys_python_pkg}-setuptools
Provides: bundled(python-requests) = 2.6.0
Url: http://aws.amazon.com/cloudformation/

%description
Bootstraps EC2 instances by retrieving and processing the Metadata block of a CloudFormation resource.

%prep
%setup -n %{name}-%{version}

%build
%{__python} setup.py build

%install
%{__python} setup.py install --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES --install-scripts=%{aws_product_path}/bin --install-data=%{aws_product_path}


%clean
rm -rf $RPM_BUILD_ROOT

%post
# Upgrade- remove old symlink
if [ "$1" = "2" ]; then
    rm -f %{aws_product_path_link}
    # also remove old init script if it exists
    if [ -e  %{_initrddir}/cfn-hup ]; then
        rm -f  %{_initrddir}/cfn-hup
    fi
fi

# Install/Upgrade - Create symlink from versioned
# directory to product name directory if it doesn't exist
if [ ! -e  %{aws_product_path_link} ]; then
    ln -s  ./%{aws_product_name_v}  %{aws_product_path_link}
fi

# Create aws bin directory if it doesn't exist:
if [ ! -d %{aws_bin_path} ]; then
    mkdir %{aws_bin_path}
fi

for command in %{aws_product_path_link}/bin/*; do
    %define command_name $(basename $command)
    if [ -e %{aws_bin_path}/%{command_name} ]; then
        if [ "$1" = "2" ]; then
            # Upgrade- remove old symlinks
            rm -f %{aws_bin_path}/%{command_name}
        fi
    fi
    if [ ! -h %{aws_bin_path}/%{command_name} ]; then
    # Install relative symlink from generic directory to aws shared directory
        ln -s ../apitools/%{aws_product_name}/bin/%{command_name}  %{aws_bin_path}/%{command_name}
    fi
done

# Create link to init script
if [ ! -e %{_initrddir}/cfn-hup ]; then
    ln -s %{aws_product_path_link}/init/redhat/cfn-hup  %{_initrddir}/cfn-hup
fi

chmod 755 %{_initrddir}/cfn-hup
chmod 755 %{aws_product_path_link}/init/redhat/cfn-hup


%preun
# Uninstall: 
if [ "$1" = "0" ]; then
    #Clean up the symlinks if it points to this version
    if [ "x$(readlink %{aws_product_path_link})" == "x./%{aws_product_name_v}" ]; then
        for command in %{aws_bin_path}/cfn*; do
            if [ "x$(readlink $command)" == "x../apitools/%{aws_product_name}/bin/$(basename $command)" ]; then
                rm -f $command
            fi
        done
    fi
fi

%postun
if [ "$1" = "0" ]; then
    if [ ! "$(ls -A %{aws_bin_path})" ]; then
        rmdir %{aws_bin_path}
    fi

    rm -f %{aws_product_path_link}

    if [ ! "$(ls -A %{aws_path}/apitools)" ]; then
        rmdir %{aws_path}/apitools
    fi

    if [ ! "$(ls -A %{aws_path})" ]; then
        rmdir %{aws_path}
    fi
fi

%files -f INSTALLED_FILES
